EDIT - task #7515

TypeDesignationStatusComparator to sort by vocabulary first and then by term order
06/26/2018 04:37 PM - Andreas Kohlbecker

Status: Resolved Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 70%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.6

Severity: normal

Description

| stumbled over this when editing possibly invalid data with the Taxeditor:

Opening the "Details View" for a name in the "Name Bulk Editor" causes an lllegalStateException when the name is associated with
specimen types and name types at the same time:

login : admin
editor version : 5.1.0.201806251348
server : localhost (localhost-dev)
schema version : 5.0.0.0.20180514
os : Linux 4.13.0-45-generic amdé64
java : 1.8.0_131
org.eclipse.swt.SWTException: Failed to execute runnable (java.lang.IllegalStateException: 2 terms
do not belong to the same vocabulary and therefore can not be compared: Epitype and lectotype)

at org.eclipse.swt.SWT.error (SWT. java:4533)

at org.eclipse.swt.SWT.error (SWT. java:4448)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer.java:185)

at org.eclipse.swt.widgets.Display.runAsyncMessages (Display.java:4536)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:4154)

at org.eclipse.ed4.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java
:1121)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ed.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:1l
022)

at org.eclipse.ed4.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)

at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

at eu.etaxonomy.taxeditor.Application.start (Application. java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLaunc
her.java:134)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:
104)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter. java:388)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter. java:243)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)

at org.eclipse.equinox.launcher.Main.run (Main.java:1519)

at org.eclipse.equinox.launcher.Main.main (Main. java:1492)
Caused by: java.lang.IllegalStateException: 2 terms do not belong to the same vocabulary and there
fore can not be compared: Epitype and lectotype

at eu.etaxonomy.cdm.model.common.OrderedTermBase.performCompareTo (OrderedTermBase. java:131)

at eu.etaxonomy.cdm.model.common.OrderedTermBase.compareTo (OrderedTermBase. java:103)

at eu.etaxonomy.cdm.api.service.name.TypeDesignationStatusComparator.compare (TypeDesignationSt
atusComparator. java:35)

at eu.etaxonomy.cdm.api.service.name.TypeDesignationComparator.compare (TypeDesignationComparat
or.java:39)

at

eu.etaxonomy.cdm.api.service.name.TypeDesignationComparator.compare (TypeDesignationComparat

or.java:20)

at
at
at
at
at
at

java.util.TimSort.binarySort (TimSort. java:296)

java.util.TimSort.sort (TimSort. java:221)

java.util.Arrays.sort (Arrays.java:1512)

java.util.ArrayList.sort (ArrayList.java:1454)

java.util.Collections.sort (Collections. java:175)
eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection.renderContent (AbstractEnt

ityCollectionSection. java:225)

at

eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection.internalUpdateSection (Abs

tractEntityCollectionSection. java:207)

at

eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection.setEntity (AbstractEntityC

ollectionSection. java:165)

at
at
at
:161)
at
a:143)
at
at

eu.etaxonomy.taxeditor.view.detail.CdmSectionPart.setFormInput (CdmSectionPart. java:155)
org.eclipse.ui.forms.ManagedForm.setInput (ManagedForm. java:210)
eu.etaxonomy.taxeditor.view.ed.AbstractCdmDataViewerE4.refresh (AbstractCdmDataViewerE4. java

eu.etaxonomy.taxeditor.view.ed.AbstractCdmDataViewerE4.setInput (AbstractCdmDataViewerE4. jav

eu.etaxonomy.taxeditor.view.ed4.details.DetailsViewerE4.setInput (DetailsViewerE4. java:194)
eu.etaxonomy.taxeditor.view.ed4.AbstractCdmEditorPartE4.showViewer (AbstractCdmEditorPartE4. j

ava:225)

at

4.java:

at

PartE4.

at
at

eu.etaxonomy.taxeditor.view.ed.details.DetailsPartE4.selectionChanged_internal (DetailsPartE
104)
eu.etaxonomy.taxeditor.view.ed.AbstractCdmEditorPartE4$DelaySelection.run (AbstractCdmEditor
java:85)
org.eclipse.swt.widgets.RunnableLock.run (RunnableLock. java:35)
org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer. java:182)

24 more

The Taxeditor should be more resilient against unusual data.

1. Suggestion as discussed with Andreas Mdller: The TypeDesignationStatusComparator should order the Terms first by the
Vocabulary and secondly by term order id.

2. The implementation of the TypeDesignationStatusComparator in principle is an OrderedTermComparator which fixes the
unorthodox inverse sort order of the cdm and which can handle a NullEntity. Maybe the diversification in multiple parallel
implementations can be harmonized into one base implementation which can be configured to work with all term types:

public

class OrderedTermComparator <T extends DefinedTermBase<?>> implements Comparator<T>{

private T nullTerm;

private canonicalSortOrder = true;

/**

*

*/

{@inheritDoc}

@Override
public int compare(T ol, T 02) {

1/

}

getters and setters

Related issues:

Related to EDIT - feature request #6794: Improve term structure In Progress
Related to EDIT - feature request #7234: Make areas in TaxEditor distribution... Closed
Related to EDIT - bug #6052: Implement Comparator for Type Designations Feedback

Associated revisions

Revision ba6cefb5 - 04/01/2019 11:27 AM - Katja Luther

ref #7515: TypedesignationStatusComparator inherit from OrderedTermComparator
Revision 1e965c67 - 04/15/2019 03:53 PM - Katja Luther

ref #7515: TypedesignationStatusComparator inherit from OrderedTermComparator

History

#1 - 08/17/2018 03:53 PM - Andreas Miller

- Target version changed from Release 5.2 to Release 5.3

#2 - 09/06/2018 08:49 PM - Katja Luther

- Target version changed from Release 5.3 to Release 5.4

#3 - 10/23/2018 10:39 AM - Andreas Miiller

- Target version changed from Release 5.4 to Release 5.5

#4 - 02/19/2019 02:44 PM - Andreas Miuller

- Target version changed from Release 5.5 to Release 5.6

#5 - 02/22/2019 10:04 AM - Katja Luther
- Priority changed from New to Highest

#6 - 02/22/2019 11:00 AM - Andreas Miiller

We may also include the upcoming new term structure (using TermCollections) #6794.

#7 - 02/22/2019 11:00 AM - Andreas Miiller

- Related to feature request #6794: Improve term structure added

#8 - 03/18/2019 02:07 PM - Katja Luther
Andreas Kohlbecker wrote:
The Taxeditor should be more resilient against unusual data.
1. Suggestion as discussed with Andreas Mller: The TypeDesignationStatusComparator should order the Terms first by the Vocabulary and

secondly by term order id.

This is already implemented in OrderTermComparator, so if TypeDesinationStatusComparator inherit from it the ordering should be like described
above.

#9 - 03/20/2019 09:14 AM - Katja Luther

- Related to feature request #7234: Make areas in TaxEditor distribution editor sortable added

#10 - 04/01/2019 11:32 AM - Katja Luther

now TypeDesignationStatusComparator inherit from OrderedTermBaseComparator

#11 - 04/01/2019 11:32 AM - Katja Luther

- Status changed from New to In Progress

#12 - 04/11/2019 12:05 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

please have a look whether this solves the problem

#13 - 04/12/2019 01:07 PM - Andreas Miiller

- Status changed from In Progress to Resolved

#14 - 12/09/2022 02:35 AM - Andreas Miiller
- % Done changed from 0 to 70
https://dev.e-taxonomy.eu/redmine/issues/6794

#15 - 03/13/2024 05:12 PM - Andreas Miiller
- Related to bug #6052: Implement Comparator for Type Designations added
